<template>
  <div class="form-container">
    <div class="flex items-center">
      <Checkbox
        v-bind="$attrs"
        v-model="value"
        :inputId="id"
        :name="name"
        :invalid="invalid"
        :binary="true"
        class="form-checkbox"
      />
      <label v-if="label" :for="id" class="form-label ml-2">
        {{ label }}
      </label>
    </div>
    <small v-if="errorMessage" class="color-danger"> {{ errorMessage }} </small>
  </div>
</template>

<script lang="ts" setup>
import Checkbox from 'primevue/checkbox'

const emit = defineEmits(['update:modelValue'])

const props = defineProps({
  modelValue: {
    type: Boolean,
    required: false,
    default: ''
  },
  id: {
    type: String,
    required: false
  },
  label: {
    type: String,
    required: false
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
})
</script>

<style lang="scss" scoped>
.form-label {
  cursor: pointer;
}
</style>
